;/*
   F_Create.rexx LIB Feelin:LIBS/Feelin/Gauge.fc 3 0
   QUIT
   ________________________________________________________________________

** (03.00) 2004/01/04

   Preference editor support.

   Supports FA_AreaData.

*/

#include "Private.h"

struct FeelinBase                  *FeelinBase;

///METHODS
F_METHOD(void,Gauge_New);
F_METHOD(void,Gauge_Set);
F_METHOD(void,Gauge_Get);
F_METHOD(void,Gauge_AskMinMax);
F_METHOD(void,Gauge_Draw);

/*** Preferences ***/

F_METHOD(void,p_Gauge_New);
F_METHOD(void,p_Gauge_Show);
F_METHOD(void,p_Gauge_Hide);
F_METHOD(void,p_Gauge_Load);
F_METHOD(void,p_Gauge_Save);
F_METHOD(void,p_Gauge_Update);
//+

F_QUERY()
{
   FeelinBase = Feelin;

   switch (Which)
   {
///Query_ClassTags
      case FV_Query_ClassTags:
      {
         static struct FeelinDynamicEntry Attributes[] =
         {
            "Simple",0, "Info",0, NULL
         };

         static struct FeelinDynamicEntry Resolve[] =
         {
            "FA_Numeric_Value",0, "FA_Numeric_Min",0, "FA_Numeric_Max",0, NULL
         };

         static struct FeelinMethodEntry Handlers[] =
         {
            (FMethod) Gauge_New,        NULL, FM_New,
            (FMethod) Gauge_Get,        NULL, FM_Get,
            (FMethod) Gauge_Set,        NULL, FM_Set,
            (FMethod) Gauge_AskMinMax,  NULL, FM_AskMinMax,
            (FMethod) Gauge_Draw,       NULL, FM_Draw,
             NULL
         };

         static struct TagItem Tags[] =
         {
            FA_Class_Super,         (ULONG) FC_Numeric,
            FA_Class_LODSize,       (ULONG) sizeof (struct LocalObjectData),
            FA_Class_Attributes,    (ULONG) Attributes,
            FA_Class_MethodsTable,  (ULONG) Handlers,
            FA_Class_ResolveTable,  (ULONG) Resolve,

            TAG_DONE
         };

         return Tags;
      }
//+
///Query_PrefsTags
      case FV_Query_PrefsTags:
      {
         static struct FeelinDynamicEntry Auto[] =
         {
            "FA_Numeric_Min", 0,
            "FA_Numeric_Max", 0,
            "FM_Numeric_Increase", 0,
             NULL
         };

         static struct FeelinMethodEntry Handlers[] =
         {
            (FMethod) p_Gauge_New,   NULL, FM_New,
            (FMethod) p_Gauge_Show,  NULL, FM_Show,
            (FMethod) p_Gauge_Hide,  NULL, FM_Hide,

            (FMethod) p_Gauge_Load,  "FM_PreferenceGroup_Load", 0,
            (FMethod) p_Gauge_Save,  "FM_PreferenceGroup_Save", 0,

            (FMethod) p_Gauge_Update,  NULL, FM_Gauge_Update,

             NULL
         };

         static struct TagItem Tags[] =
         {
            FA_Class_Super,            (ULONG) FC_PreferenceGroup,
            FA_Class_LODSize,          (ULONG) sizeof (struct p_LocalObjectData),
            FA_Class_MethodsTable,     (ULONG) Handlers,
            FA_Class_AutoResolveTable, (ULONG) Auto,
         };

         return Tags;
      }
//+
   }
   return NULL;
}

